{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link
    href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css"
    rel="stylesheet"
    integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC"
    crossorigin="anonymous"
    />
    <title>Home Page</title>
    <!-- <link rel="stylesheet" href="../static/styles/style.css" /> -->
    <style>
        @import url("https://fonts.googleapis.com/css?family=Lato");
        
        body {
            color: #fff;
            padding-top: 5%;
            background-color: #cca9dd;
        }
        
        .custom-file-upload-hidden {
            display: none;
            visibility: hidden;
            position: absolute;
            left: -9999px;
        }
        
        .custom-file-upload {
            display: block;
            width: auto;
            font-size: 16px;
            margin-top: 30px;
        }
        .custom-file-upload label {
            display: block;
            margin-bottom: 5px;
        }
        
        .file-upload-wrapper {
            position: relative;
            margin-bottom: 5px;
        }
        
        .file-upload-input {
            width: 300px;
            color: #fff;
            font-size: 16px;
            padding: 11px 17px;
            border: none;
            background-color: #cca9dd;
            -moz-transition: all 0.2s ease-in;
            -o-transition: all 0.2s ease-in;
            -webkit-transition: all 0.2s ease-in;
            transition: all 0.2s ease-in;
            /*float: left;/
            /* IE 9 Fix */
        }
        .file-upload-input:hover,
        .file-upload-input:focus {
            background-color: #af69ef;
            outline: none;
        }
        
        .file-upload-button {
            cursor: pointer;
            display: inline-block;
            color: #fff;
            font-size: 16px;
            text-transform: uppercase;
            padding: 11px 20px;
            border: none;
            margin-left: -1px;
            background-color: #bf00ff;
            /* float: left; */
            /* IE 9 Fix */
            -moz-transition: all 0.2s ease-in;
            -o-transition: all 0.2s ease-in;
            -webkit-transition: all 0.2s ease-in;
            transition: all 0.2s ease-in;
        }
        .file-upload-button:hover {
            background-color: #bf00ff;
        }
        .loading {
            display: none;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.5);
            z-index: 9999;
        }
        
        .loading-circle {
            border: 4px solid #f3f3f3;
            border-top: 4px solid #3498db;
            border-radius: 50%;
            width: 40px;
            height: 40px;
            animation: spin 2s linear infinite;
            position: absolute;
            top: 50%;
            left: 50%;
            margin-top: -20px;
            margin-left: -20px;
        }
        
        @keyframes spin {
            0% {
                transform: rotate(0deg);
            }
            100% {
                transform: rotate(360deg);
            }
        }
        .loading-countup {
            position: absolute;
            bottom: 150px;
            left: 50%;
            transform: translateX(-50%);
            font-size: 14px;
            color: #fff;
        }
    </style>
</head>

<body>
    
    <div class="container">
        
        {% for message in messages %}
        <div class="alert alert-{{ message.tags }} alert-dismissible fade show" role="alert">
            <strong>Message:</strong> {{ message }}
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        {% endfor %}
        
        <nav class="navbar navbar-expand-lg bg-white">
            <div class="container-fluid">
                <a class="navbar-brand" href="#">
                    <img src="{% static 'images/logo.png' %}" alt="Bootstrap" width="50" height="50">
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                        <li class="nav-item">
                            <span class="nav-link" style="color: black; font-size: 25px; font-weight: bold">
                                <i>
                                    Automatic Exam
                                </i>
                            </span>
                        </li>
                    </ul>
                    <a onclick="return confirm('Ingin Keluar Aplikasi ?')" href="{% url 'logout' %}" class="btn btn-danger">
                        Logout
                    </a>
                </div>
            </div>
        </nav>
    </div>
    
    <div class="container">
        
        <div class="mt-2">
            <div class="card text-center">
                <div class="card-header">
                    <h3 style="color: black">Hello {{ request.user.first_name }} {{ request.user.last_name }} </h3>
                </div>          
                <div class="card-body">
                    <form method="POST" id="myform" enctype="multipart/form-data" action="{% url 'result_data' %}">
                        {% csrf_token %}
                        <div class="custom-file-upload">
                            <input type="file" id="wavfile" name="wavfile" />
                            <br />
                            <input type="submit" name="" class="file-upload-button" value="submit"/>
                        </div>
                    </form>
                </div>
            </div>
            
            <div class="loading" id="loading">
                <div class="loading-circle"></div>
                <div id="countup" class="loading-countup">0s</div>
            </div>
        </div>
        <nav class="navbar fixed-bottom navbar-light bg-light">
            <div class="container-fluid">
                <a class="navbar-brand" href="#" style="font-size: 12px">
                    @ Copyright Aprilia
                </a>
            </div>
        </nav>
    </div>
    
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
    <script
    src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
    crossorigin="anonymous"
    ></script>
    <!-- <script src="../static/js/script.js"></script> -->
    <script
    src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.2/dist/umd/popper.min.js"
    integrity="sha384-IQsoLXl5PILFhosVNubq5LC7Qb9DXgDA9i+tQ8Zj3iwWAwPtgFTxbJ8NT4GN1R8p"
    crossorigin="anonymous"
    ></script>
    <script
    src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.min.js"
    integrity="sha384-cVKIPhGWiC2Al4u+LWgxfKTRIcfu0JTxR+EQDz/bgldoEyl4H0zUF0QKbrJ0EcQF"
    crossorigin="anonymous"
    ></script>
    <script>
        let resultroute = "{% url 'result_data' %}";
        
        (function ($) {
            var multipleSupport = typeof $("<input/>")[0].multiple !== "undefined",
            isIE = /msie/i.test(navigator.userAgent);
            
            $.fn.customFile = function () {
                return this.each(function () {
                    var $file = $(this).addClass("custom-file-upload-hidden"), // the original file input
                    $wrap = $('<div class="file-upload-wrapper">'),
                        $input = $('<input type="text" class="file-upload-input" />'),
                        // Button that will be used in non-IE browsers
                        $button = $(
                        '<button type="button" class="file-upload-button">Select a File</button>'
                        ),
                        // Hack for IE
                        $label = $(
                        '<label class="file-upload-button" for="' +
                        $file[0].id +
                        '">Select a File</label>'
                        );
                        
                        // Hide by shifting to the left so we
                        // can still trigger events
                        $file.css({
                            position: "absolute",
                            left: "-9999px",
                        });
                        
                        $wrap
                        .insertAfter($file)
                        .append($file, $input, isIE ? $label : $button);
                        
                        // Prevent focus
                        $file.attr("tabIndex", -1);
                        $button.attr("tabIndex", -1);
                        
                        $button.click(function () {
                            $file.focus().click(); // Open dialog
                        });
                        
                        $file.change(function () {
                            var files = [],
                            fileArr,
                            filename;
                            
                            // If multiple is supported then extract
                            // all filenames from the file array
                            if (multipleSupport) {
                                fileArr = $file[0].files;
                                for (var i = 0, len = fileArr.length; i < len; i++) {
                                    files.push(fileArr[i].name);
                                }
                                filename = files.join(", ");
                                
                                // If not supported then just take the value
                                // and remove the path to just show the filename
                            } else {
                                filename = $file.val().split("\\").pop();
                            }
                            
                            $input
                            .val(filename) // Set the value
                            .attr("title", filename) // Show filename in title tootlip
                            .focus(); // Regain focus
                        });
                        
                        $input.on({
                            blur: function () {
                                $file.trigger("blur");
                            },
                            keydown: function (e) {
                                if (e.which === 13) {
                                    // Enter
                                    if (!isIE) {
                                        $file.trigger("click");
                                    }
                                } else if (e.which === 8 || e.which === 46) {
                                    // Backspace & Del
                                    // On some browsers the value is read-only
                                    // with this trick we remove the old input and add
                                    // a clean clone with all the original events attached
                                    $file.replaceWith(($file = $file.clone(true)));
                                    $file.trigger("change");
                                    $input.val("");
                                } else if (e.which === 9) {
                                    // TAB
                                    return;
                                } else {
                                    // All other keys
                                    return false;
                                }
                            },
                        });
                    });
                };
                
                // Old browser fallback
                if (!multipleSupport) {
                    $(document).on("change", "input.customfile", function () {
                        var $this = $(this),
                        // Create a unique ID so we
                        // can attach the label to the input
                        uniqId = "customfile_" + new Date().getTime(),
                        $wrap = $this.parent(),
                        // Filter empty input
                        $inputs = $wrap
                        .siblings()
                        .find(".file-upload-input")
                        .filter(function () {
                            return !this.value;
                        }),
                        $file = $(
                        '<input type="file" id="' +
                        uniqId +
                        '" name="' +
                        $this.attr("name") +
                        '"/>'
                        );
                        
                        // 1ms timeout so it runs after all other events
                        // that modify the value have triggered
                        setTimeout(function () {
                            // Add a new input
                            if ($this.val()) {
                                // Check for empty fields to prevent
                                // creating new inputs when changing files
                                if (!$inputs.length) {
                                    $wrap.after($file);
                                    $file.customFile();
                                }
                                // Remove and reorganize inputs
                            } else {
                                $inputs.parent().remove();
                                // Move the input so it's always last on the list
                                $wrap.appendTo($wrap.parent());
                                $wrap.find("input").focus();
                            }
                        }, 1);
                    });
                }
            })(jQuery);
            
            $("input[type=file]").customFile();
            
            function showLoading() {
                console.log("loading");
                document.getElementById("loading").style.display = "block";
                countupAnimation();
            }
            
            function hideLoading() {
                document.getElementById("loading").style.display = "none";
            }
            
            function redirectToResult(resultId) {
                window.location.href = "{% url 'result_data' %}";// Redirect to result_data page with GET method and query parameter
            }
            
            function countupAnimation() {
                var countupElement = document.getElementById("countup");
                var startTime = new Date().getTime();
                
                function updateCountup() {
                    var currentTime = new Date().getTime();
                    var elapsedTime = currentTime - startTime;
                    countupElement.innerText = (elapsedTime / 1000).toFixed(2) + "s";
                }
                
                var interval = setInterval(updateCountup, 50);
    
                setTimeout(function () {
                    clearInterval(interval);
                    hideLoading();
                    countupElement.innerText = "Completed";
                    document.getElementById("myform").submit(); // Submit the form with POST method
                }, 3000); // Hide loading after 3 seconds (you can adjust the time as needed)
            }
            
            document.querySelector("#myform").addEventListener("submit", function (event) {
                event.preventDefault();
                var form = event.target;
                var inputFile = form.querySelector("#wavfile");
    
                if (inputFile.files.length > 0) {
                    var fileSize = inputFile.files[0].size; // Get the file size in bytes
    
                    showLoading();
    
                    var simulatedDuration = calculateSimulatedDuration(fileSize);
    
                    var interval = countupAnimation();
                    setTimeout(function () {
                        clearInterval(interval);
                        hideLoading();
                        var countupElement = document.getElementById("countup");
                        countupElement.innerText = "Completed";
                        form.submit(); // Submit the form with POST method
                    }, simulatedDuration);
                } else {
                    alert("Please select a file before submitting.");
                }
            });
            
            function calculateSimulatedDuration(fileSize) {
                // You can adjust this calculation as needed
                var duration = fileSize / 1000; // Using file size in kilobytes as a reference
                return duration;
            }
        </script>
    </body>
    </html>
    